Index: code/trunk/src/libraries/core/command/TclThreadManager.h
===================================================================
--- code/trunk/src/libraries/core/command/TclThreadManager.h	(revision 7284)
+++ code/trunk/src/libraries/core/command/TclThreadManager.h	(revision 7284)
@@ -0,0 +1,101 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _TclThreadManager_H__
+#define _TclThreadManager_H__
+
+#include "core/CorePrereqs.h"
+
+#include <cassert>
+#include <list>
+#include <map>
+#include <string>
+
+#include "util/Singleton.h"
+
+struct Tcl_Interp;
+
+namespace orxonox
+{
+    class _CoreExport TclThreadManager : public Singleton<TclThreadManager>
+    {
+        friend class Singleton<TclThreadManager>;
+        friend class TclBind;
+        friend _CoreExport void tclThread(TclInterpreterBundle* bundle, const std::string& command);
+        friend _CoreExport void sourceThread(const std::string& file);
+        friend _CoreExport int Tcl_OrxonoxAppInit(Tcl_Interp* interp);
+
+        public:
+            TclThreadManager(Tcl::interpreter* interpreter);
+            virtual ~TclThreadManager();
+
+            static unsigned int      create();
+            static Tcl::interpreter* createWithId(unsigned int id);
+            static void              destroy(unsigned int id);
+            static void              execute(unsigned int target_id, const std::string& command);
+            static std::string       query(unsigned int target_id, const std::string& command);
+            static void              source(const std::string& file);
+
+            static void error(const std::string& error);
+            static void debug(const std::string& error);
+
+            void preUpdate(const Clock& time);
+
+            std::list<unsigned int> getThreadList() const;
+
+        private:
+            static void tcl_execute(const Tcl::object& args);
+            static void tcl_crossexecute(int target_id, const Tcl::object& args);
+            static std::string tcl_query(int source_id, const Tcl::object& args);
+            static std::string tcl_crossquery(int source_id, int target_id, const Tcl::object& args);
+            static bool tcl_running(int id);
+
+            void _execute(unsigned int target_id, const std::string& command);
+            std::string _query(unsigned int source_id, unsigned int target_id, const std::string& command, bool bUseCommandExecutor = false);
+
+            TclInterpreterBundle* getInterpreterBundle(unsigned int id);
+            std::string dumpList(const std::list<unsigned int>& list);
+
+            static void initialize(TclInterpreterBundle* bundle);
+            static std::string eval(TclInterpreterBundle* bundle, const std::string& command, const std::string& action);
+
+            static TclThreadManager* singletonPtr_s;                            ///< Singleton pointer
+
+            unsigned int numInterpreterBundles_;                                ///< Number of created Tcl-interpreters (only used for auto-numbered interpreters, not affected by @ref createWithId)
+            std::map<unsigned int, TclInterpreterBundle*> interpreterBundles_;  ///< A map containing all Tcl-interpreters
+            boost::shared_mutex* interpreterBundlesMutex_;                      ///< A mutex used to synchronize threads when accessing @ref interpreterBundles_
+            TclThreadList<std::string>* messageQueue_;                          ///< A queue to pass messages from Tcl-threads to the main thread
+            boost::mutex* mainInterpreterMutex_;                                ///< A mutex to synchronize queries to the main interpreter
+    };
+
+    _CoreExport void tclThread(TclInterpreterBundle* bundle, const std::string& command);
+    _CoreExport void sourceThread(const std::string& file);
+    _CoreExport int Tcl_OrxonoxAppInit(Tcl_Interp* interp);
+}
+
+#endif /* _TclThreadManager_H__ */
Index: code/trunk/src/libraries/core/input/Button.cc
===================================================================
--- code/trunk/src/libraries/core/input/Button.cc	(revision 7278)
+++ code/trunk/src/libraries/core/input/Button.cc	(revision 7284)
@@ -39,7 +39,7 @@
 #include "util/StringUtils.h"
 #include "util/Debug.h"
-#include "core/ConsoleCommand.h"
-#include "core/CommandEvaluation.h"
-#include "core/CommandExecutor.h"
+#include "core/command/ConsoleCommand.h"
+#include "core/command/CommandEvaluation.h"
+#include "core/command/CommandExecutor.h"
 #include "core/ConfigFileManager.h"
 
@@ -117,5 +117,5 @@
         // separate the commands
         SubString commandStrings(bindingString_, "|", SubString::WhiteSpaces, false,
-            '\\', false, '"', false, '(', ')', false, '\0');
+            '\\', false, '"', false, '{', '}', false, '\0');
 
         for (unsigned int iCommand = 0; iCommand < commandStrings.size(); iCommand++)
@@ -124,5 +124,5 @@
             {
                 SubString tokens(commandStrings[iCommand], " ", SubString::WhiteSpaces, false,
-                    '\\', false, '"', false, '(', ')', false, '\0');
+                    '\\', false, '"', false, '{', '}', false, '\0');
 
                 KeybindMode::Value mode = KeybindMode::None;
@@ -175,6 +175,6 @@
 
                 // evaluate the command
-                const CommandEvaluation& eval = CommandExecutor::evaluate(commandStr);
-                if (!eval.isValid())
+                CommandEvaluation eval = CommandExecutor::evaluate(commandStr);
+                if (!eval.isValid() || eval.evaluateParams(true))
                 {
                     parseError("Command evaluation of \"" + commandStr + "\"failed.", true);
Index: code/trunk/src/libraries/core/input/HalfAxis.cc
===================================================================
--- code/trunk/src/libraries/core/input/HalfAxis.cc	(revision 7278)
+++ code/trunk/src/libraries/core/input/HalfAxis.cc	(revision 7284)
@@ -34,5 +34,5 @@
 
 #include "HalfAxis.h"
-#include "core/CommandEvaluation.h"
+#include "core/command/CommandEvaluation.h"
 
 namespace orxonox
Index: code/trunk/src/libraries/core/input/InputCommands.h
===================================================================
--- code/trunk/src/libraries/core/input/InputCommands.h	(revision 7278)
+++ code/trunk/src/libraries/core/input/InputCommands.h	(revision 7284)
@@ -37,5 +37,5 @@
 
 #include "InputPrereqs.h"
-#include "core/CommandEvaluation.h"
+#include "core/command/CommandEvaluation.h"
 
 namespace orxonox
Index: code/trunk/src/libraries/core/input/InputManager.cc
===================================================================
--- code/trunk/src/libraries/core/input/InputManager.cc	(revision 7278)
+++ code/trunk/src/libraries/core/input/InputManager.cc	(revision 7284)
@@ -47,8 +47,8 @@
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
-#include "core/ConsoleCommand.h"
 #include "core/CommandLineParser.h"
-#include "core/Functor.h"
 #include "core/GraphicsManager.h"
+#include "core/command/ConsoleCommand.h"
+#include "core/command/Functor.h"
 
 #include "InputBuffer.h"
@@ -61,4 +61,11 @@
 {
     SetCommandLineSwitch(keyboard_no_grab).information("Whether not to exclusively grab the keyboard");
+
+    static const std::string __CC_InputManager_name = "InputManager";
+    static const std::string __CC_calibrate_name = "calibrate";
+    static const std::string __CC_reload_name = "reload";
+
+    SetConsoleCommand(__CC_InputManager_name, __CC_calibrate_name, &InputManager::calibrate).addShortcut();
+    SetConsoleCommand(__CC_InputManager_name, __CC_reload_name,    &InputManager::reload   );
 
     // Abuse of this source file for the InputHandler
@@ -118,8 +125,6 @@
         this->updateActiveStates();
 
-        // calibrate console command
-        this->getIdentifier()->addConsoleCommand(createConsoleCommand(createFunctor(&InputManager::calibrate, this), "calibrate"), true);
-        // reload console command
-        this->getIdentifier()->addConsoleCommand(createConsoleCommand(createFunctor(&InputManager::reload, this), "reload"), false);
+        ModifyConsoleCommand(__CC_InputManager_name, __CC_calibrate_name).setObject(this);
+        ModifyConsoleCommand(__CC_InputManager_name, __CC_reload_name).setObject(this);
 
         CCOUT(4) << "Construction complete." << std::endl;
@@ -287,4 +292,8 @@
         if (!(internalState_ & Bad))
             this->destroyDevices();
+
+        // Reset console commands
+        ModifyConsoleCommand(__CC_InputManager_name, __CC_calibrate_name).setObject(0);
+        ModifyConsoleCommand(__CC_InputManager_name, __CC_reload_name).setObject(0);
 
         CCOUT(3) << "Destruction complete." << std::endl;
Index: code/trunk/src/libraries/core/input/InputState.cc
===================================================================
--- code/trunk/src/libraries/core/input/InputState.cc	(revision 7278)
+++ code/trunk/src/libraries/core/input/InputState.cc	(revision 7284)
@@ -28,5 +28,5 @@
 
 #include "InputState.h"
-#include "core/Functor.h"
+#include "core/command/Functor.h"
 
 namespace orxonox
Index: code/trunk/src/libraries/core/input/InputState.h
===================================================================
--- code/trunk/src/libraries/core/input/InputState.h	(revision 7278)
+++ code/trunk/src/libraries/core/input/InputState.h	(revision 7284)
@@ -150,7 +150,7 @@
         void left();
         //! Sets a functor to be called upon activation of the state
-        void setEnterFunctor(Functor* functor) { this->enterFunctor_ = functor; }
+        void setEnterFunctor(const FunctorPtr& functor) { this->enterFunctor_ = functor; }
         //! Sets a functor to be called upon deactivation of the state
-        void setLeaveFunctor(Functor* functor) { this->leaveFunctor_ = functor; }
+        void setLeaveFunctor(const FunctorPtr& functor) { this->leaveFunctor_ = functor; }
 
     private:
@@ -172,6 +172,6 @@
         //! Handler to be used for all joy sticks (needs to be saved in case another joy stick gets attached)
         InputHandler*               joyStickHandlerAll_;
-        Functor*                    enterFunctor_;          //!< Functor to be executed on enter
-        Functor*                    leaveFunctor_;          //!< Functor to be executed on leave
+        FunctorPtr                  enterFunctor_;          //!< Functor to be executed on enter
+        FunctorPtr                  leaveFunctor_;          //!< Functor to be executed on leave
     };
 
Index: code/trunk/src/libraries/core/input/KeyBinderManager.cc
===================================================================
--- code/trunk/src/libraries/core/input/KeyBinderManager.cc	(revision 7278)
+++ code/trunk/src/libraries/core/input/KeyBinderManager.cc	(revision 7284)
@@ -31,8 +31,9 @@
 #include "util/Debug.h"
 #include "util/Exception.h"
+#include "util/ScopedSingletonManager.h"
 #include "core/ConfigValueIncludes.h"
-#include "core/ConsoleCommand.h"
 #include "core/CoreIncludes.h"
-#include "core/ScopedSingletonManager.h"
+#include "core/LuaState.h"
+#include "core/command/ConsoleCommand.h"
 #include "InputManager.h"
 #include "KeyDetector.h"
@@ -41,4 +42,14 @@
 {
     ManageScopedSingleton(KeyBinderManager, ScopeID::Graphics, false);
+
+    static const std::string __CC_keybind_name = "keybind";
+    static const std::string __CC_tkeybind_name = "tkeybind";
+    static const std::string __CC_unbind_name = "unbind";
+    static const std::string __CC_tunbind_name = "tunbind";
+
+    SetConsoleCommand(__CC_keybind_name,  &KeyBinderManager::keybind).defaultValues("").argumentCompleter(0, autocompletion::command());
+    SetConsoleCommand(__CC_tkeybind_name, &KeyBinderManager::tkeybind).defaultValues("").argumentCompleter(0, autocompletion::command());
+    SetConsoleCommand(__CC_unbind_name,   &KeyBinderManager::unbind).defaultValues("");
+    SetConsoleCommand(__CC_tunbind_name,  &KeyBinderManager::tunbind).defaultValues("");
 
     KeyBinderManager::KeyBinderManager()
@@ -51,12 +62,8 @@
 
         // keybind console commands
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyBinderManager::keybind,  this), "keybind" ))
-            .defaultValues("");
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyBinderManager::tkeybind, this), "tkeybind"))
-            .defaultValues("");
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyBinderManager::unbind, this), "unbind"))
-            .defaultValues("");
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyBinderManager::tunbind, this), "tunbind"))
-            .defaultValues("");
+        ModifyConsoleCommand(__CC_keybind_name ).setObject(this);
+        ModifyConsoleCommand(__CC_tkeybind_name).setObject(this);
+        ModifyConsoleCommand(__CC_unbind_name  ).setObject(this);
+        ModifyConsoleCommand(__CC_tunbind_name ).setObject(this);
 
         // Load default key binder
@@ -69,4 +76,10 @@
         for (std::map<std::string, KeyBinder*>::const_iterator it = this->binders_.begin(); it != this->binders_.end(); ++it)
             delete it->second;
+
+        // Reset console commands
+        ModifyConsoleCommand(__CC_keybind_name ).setObject(0);
+        ModifyConsoleCommand(__CC_tkeybind_name).setObject(0);
+        ModifyConsoleCommand(__CC_unbind_name  ).setObject(0);
+        ModifyConsoleCommand(__CC_tunbind_name ).setObject(0);
     }
 
@@ -156,5 +169,5 @@
         {
             COUT(0) << "Press any button/key or move a mouse/joystick axis" << std::endl;
-            KeyDetector::getInstance().setCallback(shared_ptr<Functor>(createFunctor(&KeyBinderManager::keybindKeyPressed, this)));
+            KeyDetector::getInstance().setCallback(createFunctor(&KeyBinderManager::keybindKeyPressed, this));
             InputManager::getInstance().enterState("detector");
             this->command_ = command;
@@ -187,3 +200,8 @@
         // else: A key was probably pressed within the same tick, ignore it.
     }
+
+    void KeyBinderManager::registerKeybindCallback(LuaFunctor* function)
+    {
+        this->callbackFunction_ = function;
+    }
 }
Index: code/trunk/src/libraries/core/input/KeyBinderManager.h
===================================================================
--- code/trunk/src/libraries/core/input/KeyBinderManager.h	(revision 7278)
+++ code/trunk/src/libraries/core/input/KeyBinderManager.h	(revision 7284)
@@ -99,5 +99,5 @@
         void unbind(const std::string& binding); //tolua_export
         void tunbind(const std::string& binding);
-        inline void registerKeybindCallback(Functor* function) { this->callbackFunction_.reset(function); } // tolua_export
+        void registerKeybindCallback(LuaFunctor* function); //tolua_export
 
     private:
@@ -114,5 +114,5 @@
 
         // keybind command related
-        shared_ptr<Functor> callbackFunction_;       //! Function to be called when key was pressed after "keybind" command
+        SharedPtr<LuaFunctor> callbackFunction_;     //! Function to be called when key was pressed after "keybind" command
         bool bBinding_;                              //! Tells whether a key binding process is active
         bool bTemporary_;                            //! Stores tkeybind/keybind value
Index: code/trunk/src/libraries/core/input/KeyDetector.cc
===================================================================
--- code/trunk/src/libraries/core/input/KeyDetector.cc	(revision 7278)
+++ code/trunk/src/libraries/core/input/KeyDetector.cc	(revision 7284)
@@ -29,7 +29,7 @@
 #include "KeyDetector.h"
 
-#include "core/ConsoleCommand.h"
+#include "util/ScopedSingletonManager.h"
 #include "core/CoreIncludes.h"
-#include "core/ScopedSingletonManager.h"
+#include "core/command/ConsoleCommand.h"
 #include "Button.h"
 #include "InputManager.h"
@@ -38,6 +38,8 @@
 namespace orxonox
 {
-    std::string KeyDetector::callbackCommand_s = "KeyDetectorKeyPressed";
     ManageScopedSingleton(KeyDetector, ScopeID::Graphics, false);
+
+    static const std::string __CC_KeyDetector_callback_name = "KeyDetectorKeyPressed";
+    DeclareConsoleCommand(__CC_KeyDetector_callback_name, &prototype::void__string).hide();
 
     KeyDetector::KeyDetector()
@@ -46,5 +48,6 @@
         RegisterObject(KeyDetector);
 
-        CommandExecutor::addConsoleCommandShortcut(createConsoleCommand(createFunctor(&KeyDetector::callback,  this), callbackCommand_s));
+        ModifyConsoleCommand(__CC_KeyDetector_callback_name).setFunction(&KeyDetector::callback, this);
+
         this->assignCommands();
 
@@ -59,4 +62,5 @@
         inputState_->setHandler(NULL);
         InputManager::getInstance().destroyState("detector");
+        ModifyConsoleCommand(__CC_KeyDetector_callback_name).resetFunction();
     }
 
@@ -65,5 +69,5 @@
         // Assign every button/axis the same command, but with its name as argument
         for (std::map<std::string, Button*>::const_iterator it = allButtons_.begin(); it != allButtons_.end(); ++it)
-            it->second->parse(callbackCommand_s + ' ' + it->second->groupName_ + "." + it->second->name_);
+            it->second->parse(__CC_KeyDetector_callback_name + ' ' + it->second->groupName_ + "." + it->second->name_);
     }
 
Index: code/trunk/src/libraries/core/input/KeyDetector.h
===================================================================
--- code/trunk/src/libraries/core/input/KeyDetector.h	(revision 7278)
+++ code/trunk/src/libraries/core/input/KeyDetector.h	(revision 7284)
@@ -46,5 +46,5 @@
         ~KeyDetector();
 
-        void setCallback(const shared_ptr<Functor>& function) { this->callbackFunction_ = function; }
+        void setCallback(const FunctorPtr& function) { this->callbackFunction_ = function; }
 
     private:
@@ -55,7 +55,6 @@
         void assignCommands();
 
-        shared_ptr<Functor> callbackFunction_;
+        FunctorPtr callbackFunction_;
         InputState* inputState_;
-        static std::string callbackCommand_s;
         static KeyDetector* singletonPtr_s;
     };
Index: code/trunk/src/libraries/core/input/Mouse.cc
===================================================================
--- code/trunk/src/libraries/core/input/Mouse.cc	(revision 7278)
+++ code/trunk/src/libraries/core/input/Mouse.cc	(revision 7284)
@@ -30,6 +30,6 @@
 
 #include <ois/OISMouse.h>
-#include "core/ConsoleCommand.h"
 #include "core/CoreIncludes.h"
+#include "core/command/ConsoleCommand.h"
 #include "InputState.h"
 
@@ -41,4 +41,13 @@
 namespace orxonox
 {
+#ifdef ORXONOX_PLATFORM_LINUX
+    static const std::string __CC_Mouse_name = "Mouse";
+    static const std::string __CC_grab_name = "grab";
+    static const std::string __CC_ungrab_name = "ungrab";
+
+    SetConsoleCommand(__CC_Mouse_name, __CC_grab_name,   &Mouse::grab);
+    SetConsoleCommand(__CC_Mouse_name, __CC_ungrab_name, &Mouse::ungrab);
+#endif
+
     Mouse::Mouse(unsigned int id, OIS::InputManager* oisInputManager)
         : super(id, oisInputManager)
@@ -48,8 +57,14 @@
 
 #ifdef ORXONOX_PLATFORM_LINUX
-        // Mouse grab console command
-        this->getIdentifier()->addConsoleCommand(createConsoleCommand(createFunctor(&Mouse::grab, this), "grab"), false);
-        // Mouse ungrab console command
-        this->getIdentifier()->addConsoleCommand(createConsoleCommand(createFunctor(&Mouse::ungrab, this), "ungrab"), false);
+        ModifyConsoleCommand(__CC_Mouse_name, __CC_grab_name).setObject(this);
+        ModifyConsoleCommand(__CC_Mouse_name, __CC_ungrab_name).setObject(this);
+#endif
+    }
+
+    Mouse::~Mouse()
+    {
+#ifdef ORXONOX_PLATFORM_LINUX
+        ModifyConsoleCommand(__CC_Mouse_name, __CC_grab_name).setObject(0);
+        ModifyConsoleCommand(__CC_Mouse_name, __CC_ungrab_name).setObject(0);
 #endif
     }
Index: code/trunk/src/libraries/core/input/Mouse.h
===================================================================
--- code/trunk/src/libraries/core/input/Mouse.h	(revision 7278)
+++ code/trunk/src/libraries/core/input/Mouse.h	(revision 7284)
@@ -64,5 +64,5 @@
         //! Only sets the clipping size. Initialising is done in the base class.
         Mouse(unsigned int id, OIS::InputManager* oisInputManager);
-        ~Mouse() { }
+        ~Mouse();
 
 #ifdef ORXONOX_PLATFORM_LINUX
Index: code/trunk/src/libraries/network/Client.cc
===================================================================
--- code/trunk/src/libraries/network/Client.cc	(revision 7278)
+++ code/trunk/src/libraries/network/Client.cc	(revision 7284)
@@ -45,4 +45,5 @@
 #include "util/Clock.h"
 #include "util/Debug.h"
+#include "util/ScopedSingletonManager.h"
 #include "synchronisable/Synchronisable.h"
 #include "packet/Chat.h"
@@ -52,5 +53,4 @@
 #include "core/CommandLineParser.h"
 #include "core/Game.h"
-#include "core/ScopedSingletonManager.h"
 
 namespace orxonox
@@ -107,5 +107,5 @@
     return ClientConnection::closeConnection();
   }
-  
+
   void Client::setDestination(const std::string& serverAddress, unsigned int port)
   {
Index: code/trunk/src/libraries/network/ClientConnection.cc
===================================================================
--- code/trunk/src/libraries/network/ClientConnection.cc	(revision 7278)
+++ code/trunk/src/libraries/network/ClientConnection.cc	(revision 7284)
@@ -149,6 +149,8 @@
   uint32_t ClientConnection::getRTT()
   {
-    assert(server_);
-    return server_->roundTripTime;
+    if (server_)
+        return server_->roundTripTime;
+    else
+        return 0;
   }
 
Index: code/trunk/src/libraries/network/GamestateManager.cc
===================================================================
--- code/trunk/src/libraries/network/GamestateManager.cc	(revision 7278)
+++ code/trunk/src/libraries/network/GamestateManager.cc	(revision 7284)
@@ -47,6 +47,6 @@
 
 #include "util/Debug.h"
-#include "core/Executor.h"
 #include "core/ThreadPool.h"
+#include "core/command/Executor.h"
 #include "ClientInformation.h"
 #include "packet/Acknowledgement.h"
Index: code/trunk/src/libraries/network/Host.cc
===================================================================
--- code/trunk/src/libraries/network/Host.cc	(revision 7278)
+++ code/trunk/src/libraries/network/Host.cc	(revision 7284)
@@ -32,11 +32,14 @@
 #include <string>
 
-#include "core/ConsoleCommand.h"
 #include "core/ObjectList.h"
+#include "core/command/ConsoleCommand.h"
 #include "ChatListener.h"
 
 namespace orxonox {
 
-  SetConsoleCommandShortcut(Host, Chat);
+  static const std::string __CC_printRTT_name = "printRTT";
+
+  SetConsoleCommand("chat", &Host::Chat);
+  SetConsoleCommand(__CC_printRTT_name, &Host::printRTT);
 
   // Host*               Host::instance_=0;
@@ -52,6 +55,5 @@
   //   assert(instance_==0);
     instances_s.push_back(this);
-    this->printRTTCC_ = createConsoleCommand( createFunctor(&Host::printRTT, this), "printRTT" );
-    CommandExecutor::addConsoleCommandShortcut( this->printRTTCC_ );
+    ModifyConsoleCommand(__CC_printRTT_name).setObject(this);
     this->bIsActive_ = false;
   }
@@ -65,6 +67,5 @@
     assert( std::find( instances_s.begin(), instances_s.end(), this )!=instances_s.end() );
     instances_s.erase(std::find( instances_s.begin(), instances_s.end(), this ));
-    if( this->printRTTCC_ )
-      delete this->printRTTCC_;
+    ModifyConsoleCommand(__CC_printRTT_name).setObject(0);
   }
 
@@ -89,5 +90,5 @@
   }
 
-  bool Host::Chat(const std::string& message)
+  void Host::Chat(const std::string& message)
   {
     if(instances_s.size()==0)
@@ -95,5 +96,5 @@
       for (ObjectList<ChatListener>::iterator it = ObjectList<ChatListener>::begin(); it != ObjectList<ChatListener>::end(); ++it)
         it->incomingChat(message, 0);
-      return true;
+//      return true;
     }
     else
@@ -108,5 +109,5 @@
         }
       }
-      return result;
+//      return result;
     }
   }
@@ -139,5 +140,5 @@
     for (ObjectList<ChatListener>::iterator it = ObjectList<ChatListener>::begin(); it != ObjectList<ChatListener>::end(); ++it)
       it->incomingChat(message, playerID);
-    
+
     bool result = true;
     for( std::vector<Host*>::iterator it = instances_s.begin(); it!=instances_s.end(); ++it )
Index: code/trunk/src/libraries/network/Host.h
===================================================================
--- code/trunk/src/libraries/network/Host.h	(revision 7278)
+++ code/trunk/src/libraries/network/Host.h	(revision 7284)
@@ -79,5 +79,5 @@
     static void setShipID(unsigned int id){ shipID_s = id; }
     static bool isServer();
-    static bool Chat(const std::string& message);
+    static void Chat(const std::string& message);
     static bool Broadcast(const std::string& message);
     static bool incomingChat(const std::string& message, unsigned int playerID);
@@ -85,5 +85,4 @@
     bool isActive(){ return bIsActive_; }
   private:
-    ConsoleCommand* printRTTCC_;
     static uint32_t clientID_s;
     static uint32_t shipID_s;
Index: code/trunk/src/libraries/network/LANDiscovery.cc
===================================================================
--- code/trunk/src/libraries/network/LANDiscovery.cc	(revision 7278)
+++ code/trunk/src/libraries/network/LANDiscovery.cc	(revision 7284)
@@ -32,12 +32,12 @@
 #include <cstring>
 
+#include "util/ScopedSingletonManager.h"
 #include "core/CoreIncludes.h"
-#include "core/ScopedSingletonManager.h"
 
 
 namespace orxonox
-{ 
+{
   ManageScopedSingleton(LANDiscovery, ScopeID::Root, true);
-  
+
   LANDiscovery::LANDiscovery()
   {
@@ -49,5 +49,5 @@
     enet_host_destroy(this->host_);
   }
-  
+
   void LANDiscovery::discover()
   {
@@ -56,8 +56,8 @@
     enet_address_set_host(&address, "255.255.255.255");
     address.port = LAN_DISCOVERY_PORT;
-    
+
     ENetPeer* peer;
     peer = enet_host_connect(this->host_, &address, 0);
-    
+
     ENetEvent event;
     while( enet_host_service(this->host_, &event, 1000 ) )
@@ -93,5 +93,5 @@
     }
   }
-  
+
   std::string LANDiscovery::getServerListItemName(unsigned int index)
   {
@@ -101,5 +101,5 @@
       return this->servers_[index].getServerName();
   }
-  
+
   std::string LANDiscovery::getServerListItemIP(unsigned int index)
   {
@@ -109,5 +109,5 @@
       return this->servers_[index].getServerIP();
   }
-  
-  
+
+
 } // namespace orxonox
Index: code/trunk/src/libraries/network/NetworkFunction.cc
===================================================================
--- code/trunk/src/libraries/network/NetworkFunction.cc	(revision 7278)
+++ code/trunk/src/libraries/network/NetworkFunction.cc	(revision 7284)
@@ -68,5 +68,5 @@
 
 
-  NetworkFunctionStatic::NetworkFunctionStatic(FunctorStatic* functor, const std::string& name, const NetworkFunctionPointer& p):
+  NetworkFunctionStatic::NetworkFunctionStatic(const FunctorStaticPtr& functor, const std::string& name, const NetworkFunctionPointer& p):
     NetworkFunctionBase(name)
   {
@@ -76,9 +76,4 @@
     NetworkFunctionStatic::getFunctorMap()[p] = this;
     NetworkFunctionStatic::getIdMap()[ this->getNetworkID() ] = this;
-  }
-
-  NetworkFunctionStatic::~NetworkFunctionStatic()
-  {
-    delete this->functor_;
   }
 
Index: code/trunk/src/libraries/network/NetworkFunction.h
===================================================================
--- code/trunk/src/libraries/network/NetworkFunction.h	(revision 7278)
+++ code/trunk/src/libraries/network/NetworkFunction.h	(revision 7284)
@@ -39,6 +39,6 @@
 #include <boost/static_assert.hpp>
 
-#include "core/Functor.h"
 #include "core/Identifier.h"
+#include "core/command/Functor.h"
 #include "FunctionCallManager.h"
 #include "synchronisable/Synchronisable.h"
@@ -102,6 +102,5 @@
 class _NetworkExport NetworkFunctionStatic: public NetworkFunctionBase {
   public:
-    NetworkFunctionStatic(FunctorStatic* functor, const std::string& name, const NetworkFunctionPointer& p);
-    ~NetworkFunctionStatic();
+    NetworkFunctionStatic(const FunctorStaticPtr& functor, const std::string& name, const NetworkFunctionPointer& p);
 
     inline void call(){ (*this->functor_)(); }
@@ -124,5 +123,5 @@
     static std::map<NetworkFunctionPointer, NetworkFunctionStatic*>& getFunctorMap();
     static std::map<uint32_t, NetworkFunctionStatic*>& getIdMap();
-    FunctorStatic* functor_;
+    FunctorStaticPtr functor_;
 
 };
@@ -155,6 +154,5 @@
 template <class T> class NetworkMemberFunction: public NetworkMemberFunctionBase {
   public:
-    NetworkMemberFunction(FunctorMember<T>* functor, const std::string& name, const NetworkFunctionPointer& p);
-    ~NetworkMemberFunction();
+    NetworkMemberFunction(const FunctorMemberPtr<T>& functor, const std::string& name, const NetworkFunctionPointer& p);
 
     inline void call(uint32_t objectID)
@@ -190,14 +188,10 @@
 
   private:
-    FunctorMember<T>* functor_;
-};
-
-template <class T> NetworkMemberFunction<T>::NetworkMemberFunction(FunctorMember<T>* functor, const std::string& name, const NetworkFunctionPointer& p):
+    FunctorMemberPtr<T> functor_;
+};
+
+template <class T> NetworkMemberFunction<T>::NetworkMemberFunction(const FunctorMemberPtr<T>& functor, const std::string& name, const NetworkFunctionPointer& p):
     NetworkMemberFunctionBase(name, p), functor_(functor)
 {
-}
-template <class T> NetworkMemberFunction<T>::~NetworkMemberFunction()
-{
-  delete this->functor_;
 }
 
Index: code/trunk/src/libraries/network/Server.cc
===================================================================
--- code/trunk/src/libraries/network/Server.cc	(revision 7278)
+++ code/trunk/src/libraries/network/Server.cc	(revision 7284)
@@ -49,5 +49,5 @@
 #include "util/Debug.h"
 #include "core/ObjectList.h"
-#include "core/Executor.h"
+#include "core/command/Executor.h"
 #include "packet/Chat.h"
 #include "packet/ClassID.h"
